= nng_http_res_alloc_error(3http)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_http_res_alloc_error - allocate HTTP error response

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>
#include <nng/supplemental/http/http.h>

int nng_http_res_alloc_error(nng_http_res **resp, uint16_t status);
----

== DESCRIPTION

The `nng_http_res_alloc_error()` function allocates a new HTTP response structure
and stores a pointer to it in __resp__.
The response will be initialized
with the status code _status_, a corresponding reason phrase, and
a simple HTML page containing the same information will be generated and
attached to the response.
(Relevant HTTP headers will be set as well, such as `Content-Type`
and `Content-Length`.)
The HTTP protocol version is also set to "HTTP/1.1".

TIP: This is the simplest way to generate an error response.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ENOMEM`:: Insufficient free memory exists to allocate a message.
`NNG_ENOTSUP`:: HTTP support not configured.

== SEE ALSO

[.text-left]
xref:nng_http_res_alloc.3http.adoc[nng_http_res_alloc(3http)],
xref:nng_http_res_free.3http.adoc[nng_http_res_free(3http)],
xref:nng_http_res_set_reason.3http.adoc[nng_http_res_set_reason(3http)],
xref:nng_http_res_set_status.3http.adoc[nng_http_res_set_status(3http)],
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng.7.adoc[nng(7)]
